
/*******************************************************************************
* Freescale Semiconductor Inc.
* (c) Copyright 2004-2005 Freescale Semiconductor, Inc.
* ALL RIGHTS RESERVED.
********************************************************************************
Services performed by FREESCALE in this matter are performed AS IS and without 
any warranty. CUSTOMER retains the final decision relative to the total design 
and functionality of the end product. FREESCALE neither guarantees nor will be 
held liable by CUSTOMER for the success of this project.
FREESCALE DISCLAIMS ALL WARRANTIES, EXPRESSED, IMPLIED OR STATUTORY INCLUDING, 
BUT NOT LIMITED TO, IMPLIED WARRANTY OF MERCHANTABILITY OR FITNESS FOR 
A PARTICULAR PURPOSE ON ANY HARDWARE, SOFTWARE ORE ADVISE SUPPLIED TO THE PROJECT
BY FREESCALE, AND OR NAY PRODUCT RESULTING FROM FREESCALE SERVICES. IN NO EVENT
SHALL FREESCALE BE LIABLE FOR INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF 
THIS AGREEMENT.

CUSTOMER agrees to hold FREESCALE harmless against any and all claims demands or 
actions by anyone on account of any damage, or injury, whether commercial, 
contractual, or tortuous, rising directly or indirectly as a result of the advise
or assistance supplied CUSTOMER in connection with product, services or goods 
supplied under this Agreement.
********************************************************************************
* File              main_p1.c
* Owner             b05111
* Version           0.0
* Date              Aug-08-2014
* Classification    General Business Information
* Brief             Blinking LED
********************************************************************************
* Detailed Description:
********************************************************************************
Revision History:
Version  Date         Author        Description of Changes
0.0_DPM  Aug-08-2014  b05111        Initial Version
0.1_DPM  Jul-28-2015  b05111        Addded optimizations
*******************************************************************************/

#include "MPC5643L.h"
#include "Optimizations.h"

/*******************************************************************************
* External objects
*******************************************************************************/


/*******************************************************************************
* Global variables
*******************************************************************************/


/*******************************************************************************
* Constants and macros
*******************************************************************************/

#define OPTIMIZATIONS_ON 1

/* PCR numbers */
#define PD5_pin 53  
#define LED2_pin   PD5_pin


/*******************************************************************************
* Local types
*******************************************************************************/


/*******************************************************************************
* Local function prototypes
*******************************************************************************/

int main_p1(void);
static void GPIO_init(void);


/*******************************************************************************
* Local variables
*******************************************************************************/


/*******************************************************************************
* Local functions
*******************************************************************************/

/*******************************************************************************
Function Name : GPIO_init
Engineer      : b05111
Date          : Aug-08-2014
Parameters    : NONE
Modifies      : NONE
Returns       : NONE
Notes         : 
Issues        : NONE
*******************************************************************************/
static void GPIO_init(void)
{    	 	
    SIU.GPDO[LED2_pin].R = 1;
    SIU.PCR[LED2_pin].B.PA = 0x00;
    SIU.PCR[LED2_pin].B.OBE = 0x01;
}


/*******************************************************************************
* Global functions
*******************************************************************************/

int main_p1(void) 
{    
    vuint32_t counter = 0;
    
    GPIO_init();
    Core_optimizations();
    
    SIU.GPDO[LED2_pin].R = 1;
    
    /* Loop forever */
    while (1) 
    {

        /* delay */
        while(counter < 1000000)
        {
            counter++;
        }
        counter = 0;
        
        /* toggle LED */
        SIU.GPDO[LED2_pin].R ^= 1;
    }
    

}
 
